----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:11:12 06/13/2007 
-- Design Name: 
-- Module Name:    mux32_3 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux32_3 is
    Port ( a : in  STD_LOGIC_VECTOR (31 downto 0);
           b : in  STD_LOGIC_VECTOR (31 downto 0);
           c : in  STD_LOGIC_VECTOR (31 downto 0);
           selector : in  STD_LOGIC_VECTOR (1 downto 0);
           selected : out  STD_LOGIC_VECTOR (31 downto 0));
end mux32_3;

architecture Behavioral of mux32_3 is

begin

	process (selector, a, b, c)
	begin
		case selector is
			when "00" =>
				selected <= a;
			when "01" =>
				selected <= b;
			when "10" => 
				selected <= c;			
			when others =>
				selected <= "11111111111111111111111111111111";
		end case;
	end process;

end Behavioral;

