--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : xy_calc.vhf
-- /___/   /\     Timestamp : 07/01/2007 21:39:26
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx91i\bin\nt\sch2vhdl.exe -intstyle ise -family virtex4 -flat -suppress -w C:/projetos/Multilateration_05b_final_missing_testbenchs/xy_calc.sch xy_calc.vhf
--Design Name: xy_calc
--Device: virtex4
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity xy_calc is
   port ( clk        : in    std_logic; 
          div_factor : in    std_logic_vector (31 downto 0); 
          num_x      : in    std_logic_vector (31 downto 0); 
          num_y      : in    std_logic_vector (31 downto 0); 
          reset      : in    std_logic; 
          start      : in    std_logic; 
          rdy        : out   std_logic; 
          x          : out   std_logic_vector (31 downto 0); 
          y          : out   std_logic_vector (31 downto 0));
end xy_calc;

architecture BEHAVIORAL of xy_calc is
   signal XLXN_19    : std_logic_vector (31 downto 0);
   signal XLXN_27    : std_logic_vector (31 downto 0);
   signal XLXN_29    : std_logic;
   signal XLXN_43    : std_logic_vector (31 downto 0);
   signal XLXN_48    : std_logic;
   signal XLXN_52    : std_logic;
   signal XLXN_53    : std_logic;
   signal XLXN_54    : std_logic;
   component div_fp
      port ( a             : in    std_logic_vector (31 downto 0); 
             b             : in    std_logic_vector (31 downto 0); 
             operation_nd  : in    std_logic; 
             operation_rfd : out   std_logic; 
             sclr          : in    std_logic; 
             clk           : in    std_logic; 
             result        : out   std_logic_vector (31 downto 0); 
             rdy           : out   std_logic);
   end component;
   
   component mux32_2
      port ( SELECTOR : in    std_logic; 
             A        : in    std_logic_vector (31 downto 0); 
             B        : in    std_logic_vector (31 downto 0); 
             OUTPUT   : out   std_logic_vector (31 downto 0));
   end component;
   
   component reg32
      port ( LOAD   : in    std_logic; 
             RESET  : in    std_logic; 
             CLK    : in    std_logic; 
             INPUT  : in    std_logic_vector (31 downto 0); 
             OUTPUT : out   std_logic_vector (31 downto 0));
   end component;
   
   component XY_CALC_CONTROL
      port ( CLK           : in    std_logic; 
             div_rdy       : in    std_logic; 
             sclr          : in    std_logic; 
             start         : in    std_logic; 
             div_a_mux_sel : out   std_logic; 
             div_nd        : out   std_logic; 
             rdy           : out   std_logic; 
             x_reg_load    : out   std_logic; 
             y_reg_load    : out   std_logic);
   end component;
   
begin
   div_fp_1 : div_fp
      port map (a(31 downto 0)=>XLXN_19(31 downto 0),
                b(31 downto 0)=>div_factor(31 downto 0),
                clk=>clk,
                operation_nd=>XLXN_52,
                sclr=>reset,
                operation_rfd=>open,
                rdy=>XLXN_29,
                result(31 downto 0)=>XLXN_27(31 downto 0));
   
   XLXI_2 : mux32_2
      port map (A(31 downto 0)=>num_x(31 downto 0),
                B(31 downto 0)=>num_y(31 downto 0),
                SELECTOR=>XLXN_48,
                OUTPUT(31 downto 0)=>XLXN_19(31 downto 0));
   
   XLXI_7 : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_27(31 downto 0),
                LOAD=>XLXN_29,
                RESET=>reset,
                OUTPUT(31 downto 0)=>XLXN_43(31 downto 0));
   
   XLXI_8 : XY_CALC_CONTROL
      port map (CLK=>clk,
                div_rdy=>XLXN_29,
                sclr=>reset,
                start=>start,
                div_a_mux_sel=>XLXN_48,
                div_nd=>XLXN_52,
                rdy=>rdy,
                x_reg_load=>XLXN_54,
                y_reg_load=>XLXN_53);
   
   x_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_43(31 downto 0),
                LOAD=>XLXN_54,
                RESET=>reset,
                OUTPUT(31 downto 0)=>x(31 downto 0));
   
   y_reg : reg32
      port map (CLK=>clk,
                INPUT(31 downto 0)=>XLXN_43(31 downto 0),
                LOAD=>XLXN_53,
                RESET=>reset,
                OUTPUT(31 downto 0)=>y(31 downto 0));
   
end BEHAVIORAL;


