VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "virtex4"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL XLXN_1(31:0)
        SIGNAL XLXN_2(31:0)
        SIGNAL XLXN_8(31:0)
        SIGNAL XLXN_10(31:0)
        SIGNAL XLXN_11(31:0)
        SIGNAL EXP1(31:0)
        SIGNAL EXP2(31:0)
        SIGNAL EXP3(31:0)
        SIGNAL XLXN_24(31:0)
        SIGNAL DIVFACTOR(31:0)
        SIGNAL CLK
        SIGNAL MUL1_RDY
        SIGNAL sub1_rdy
        SIGNAL RDY
        SIGNAL XLXN_69
        SIGNAL XLXN_72
        SIGNAL sub_nd
        SIGNAL XLXN_75
        SIGNAL RESET
        SIGNAL XLXN_86(31:0)
        SIGNAL START
        SIGNAL XLXN_93
        PORT Input EXP1(31:0)
        PORT Input EXP2(31:0)
        PORT Input EXP3(31:0)
        PORT Output DIVFACTOR(31:0)
        PORT Input CLK
        PORT Output RDY
        PORT Input RESET
        PORT Input START
        BEGIN BLOCKDEF reg32
            TIMESTAMP 2007 6 27 20 6 4
            RECTANGLE N 64 -256 368 0 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF mux32_2
            TIMESTAMP 2007 6 27 20 5 36
            RECTANGLE N 64 -192 368 0 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -172 432 -148 
            LINE N 368 -160 432 -160 
        END BLOCKDEF
        BEGIN BLOCKDEF mult_fp
            TIMESTAMP 2007 6 29 1 14 46
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCKDEF DIV_FACTOR_CONTROL
            TIMESTAMP 2007 6 29 1 27 0
            RECTANGLE N 64 -384 416 0 
            LINE N 64 -352 0 -352 
            LINE N 64 -272 0 -272 
            LINE N 64 -192 0 -192 
            LINE N 64 -112 0 -112 
            LINE N 64 -32 0 -32 
            LINE N 416 -352 480 -352 
            LINE N 416 -288 480 -288 
            LINE N 416 -224 480 -224 
            LINE N 416 -160 480 -160 
            LINE N 416 -96 480 -96 
            LINE N 416 -32 480 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF sub_fp
            TIMESTAMP 2007 6 29 1 12 38
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCK PARTIAL_REG reg32
            PIN LOAD XLXN_93
            PIN RESET RESET
            PIN CLK CLK
            PIN INPUT(31:0) XLXN_24(31:0)
            PIN OUTPUT(31:0) XLXN_86(31:0)
        END BLOCK
        BEGIN BLOCK MUX1 mux32_2
            PIN SELECTOR XLXN_75
            PIN A(31:0) XLXN_1(31:0)
            PIN B(31:0) XLXN_8(31:0)
            PIN OUTPUT(31:0) XLXN_10(31:0)
        END BLOCK
        BEGIN BLOCK MUX2 mux32_2
            PIN SELECTOR XLXN_75
            PIN A(31:0) XLXN_2(31:0)
            PIN B(31:0) XLXN_8(31:0)
            PIN OUTPUT(31:0) XLXN_11(31:0)
        END BLOCK
        BEGIN BLOCK MULT1 mult_fp
            PIN a(31:0) XLXN_10(31:0)
            PIN b(31:0) XLXN_11(31:0)
            PIN operation_nd XLXN_72
            PIN operation_rfd
            PIN sclr RESET
            PIN clk CLK
            PIN result(31:0) XLXN_24(31:0)
            PIN rdy MUL1_RDY
        END BLOCK
        BEGIN BLOCK REG1 reg32
            PIN LOAD XLXN_69
            PIN RESET RESET
            PIN CLK CLK
            PIN INPUT(31:0) EXP1(31:0)
            PIN OUTPUT(31:0) XLXN_1(31:0)
        END BLOCK
        BEGIN BLOCK REG2 reg32
            PIN LOAD XLXN_69
            PIN RESET RESET
            PIN CLK CLK
            PIN INPUT(31:0) EXP2(31:0)
            PIN OUTPUT(31:0) XLXN_2(31:0)
        END BLOCK
        BEGIN BLOCK REG3 reg32
            PIN LOAD XLXN_69
            PIN RESET RESET
            PIN CLK CLK
            PIN INPUT(31:0) EXP3(31:0)
            PIN OUTPUT(31:0) XLXN_8(31:0)
        END BLOCK
        BEGIN BLOCK CTRL DIV_FACTOR_CONTROL
            PIN CLK CLK
            PIN MULT1_RDY MUL1_RDY
            PIN SCLR RESET
            PIN START START
            PIN SUB1_RDY sub1_rdy
            PIN LOAD_PART_REG XLXN_93
            PIN LOAD_REGS XLXN_69
            PIN MULT1_ND XLXN_72
            PIN MUX_SEL XLXN_75
            PIN RDY RDY
            PIN SUB_ND sub_nd
        END BLOCK
        BEGIN BLOCK sub1 sub_fp
            PIN a(31:0) XLXN_24(31:0)
            PIN b(31:0) XLXN_86(31:0)
            PIN operation_nd sub_nd
            PIN operation_rfd
            PIN sclr RESET
            PIN clk CLK
            PIN result(31:0) DIVFACTOR(31:0)
            PIN rdy sub1_rdy
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH XLXN_1(31:0)
            WIRE 768 96 832 96
            WIRE 832 96 832 432
            WIRE 832 432 880 432
        END BRANCH
        BEGIN BRANCH XLXN_2(31:0)
            WIRE 720 688 752 688
            WIRE 752 688 752 1056
            WIRE 752 1056 880 1056
        END BRANCH
        BEGIN INSTANCE MUX1 880 528 R0
        END INSTANCE
        BEGIN INSTANCE MUX2 880 1152 R0
        END INSTANCE
        BEGIN BRANCH XLXN_8(31:0)
            WIRE 704 1328 832 1328
            WIRE 832 496 832 1120
            WIRE 832 1120 880 1120
            WIRE 832 1120 832 1328
            WIRE 832 496 880 496
        END BRANCH
        BEGIN BRANCH XLXN_10(31:0)
            WIRE 1312 368 1328 368
            WIRE 1328 368 1328 624
            WIRE 1328 624 1584 624
        END BRANCH
        BEGIN BRANCH XLXN_11(31:0)
            WIRE 1312 992 1328 992
            WIRE 1328 656 1584 656
            WIRE 1328 656 1328 992
        END BRANCH
        BEGIN INSTANCE MULT1 1584 544 R0
        END INSTANCE
        BEGIN BRANCH EXP1(31:0)
            WIRE 176 288 336 288
        END BRANCH
        BEGIN BRANCH EXP2(31:0)
            WIRE 176 880 288 880
        END BRANCH
        BEGIN BRANCH EXP3(31:0)
            WIRE 176 1520 272 1520
        END BRANCH
        BEGIN BRANCH DIVFACTOR(31:0)
            WIRE 3264 672 3280 672
        END BRANCH
        IOMARKER 3280 672 DIVFACTOR(31:0) R0 28
        IOMARKER 176 288 EXP1(31:0) R180 28
        IOMARKER 176 880 EXP2(31:0) R180 28
        IOMARKER 176 1520 EXP3(31:0) R180 28
        BEGIN BRANCH RDY
            WIRE 1328 2208 1344 2208
            WIRE 1344 2208 1472 2208
        END BRANCH
        IOMARKER 256 1920 CLK R90 28
        BEGIN BRANCH XLXN_72
            WIRE 1328 2080 1568 2080
            WIRE 1568 752 1584 752
            WIRE 1568 752 1568 2080
        END BRANCH
        BEGIN BRANCH XLXN_75
            WIRE 848 368 880 368
            WIRE 848 368 848 896
            WIRE 848 896 848 992
            WIRE 848 992 880 992
            WIRE 848 896 1360 896
            WIRE 1360 896 1360 2144
            WIRE 1328 2144 1360 2144
        END BRANCH
        BEGIN BRANCH XLXN_24(31:0)
            WIRE 2096 624 2192 624
            WIRE 2192 624 2208 624
            WIRE 2192 624 2192 672
            WIRE 2192 672 2752 672
        END BRANCH
        BEGIN INSTANCE CTRL 848 2304 R0
        END INSTANCE
        BEGIN BRANCH START
            WIRE 464 2192 848 2192
        END BRANCH
        IOMARKER 464 2192 START R180 28
        BEGIN INSTANCE REG1 336 320 R0
        END INSTANCE
        BEGIN INSTANCE REG2 288 912 R0
        END INSTANCE
        BEGIN BRANCH XLXN_69
            WIRE 192 96 192 688
            WIRE 192 688 192 1296
            WIRE 192 1296 1376 1296
            WIRE 1376 1296 1376 2016
            WIRE 192 1296 192 1328
            WIRE 192 1328 272 1328
            WIRE 192 688 288 688
            WIRE 192 96 336 96
            WIRE 1328 2016 1376 2016
        END BRANCH
        BEGIN INSTANCE REG3 272 1552 R0
        END INSTANCE
        BEGIN INSTANCE PARTIAL_REG 2208 656 R0
        END INSTANCE
        BEGIN BRANCH XLXN_93
            WIRE 1328 1952 1392 1952
            WIRE 1392 432 2208 432
            WIRE 1392 432 1392 1952
        END BRANCH
        IOMARKER 320 2464 RESET R90 28
        BEGIN BRANCH RESET
            WIRE 224 160 336 160
            WIRE 224 160 224 752
            WIRE 224 752 288 752
            WIRE 224 752 224 1392
            WIRE 224 1392 272 1392
            WIRE 224 1392 224 1680
            WIRE 224 1680 320 1680
            WIRE 320 1680 320 2112
            WIRE 320 2112 848 2112
            WIRE 320 2112 320 2464
            WIRE 320 1680 1552 1680
            WIRE 1552 1680 2144 1680
            WIRE 2144 1680 2448 1680
            WIRE 1552 848 1584 848
            WIRE 1552 848 1552 1680
            WIRE 2144 496 2208 496
            WIRE 2144 496 2144 1680
            WIRE 2448 896 2448 1680
            WIRE 2448 896 2752 896
        END BRANCH
        BEGIN BRANCH CLK
            WIRE 256 224 336 224
            WIRE 256 224 256 816
            WIRE 256 816 288 816
            WIRE 256 816 256 1456
            WIRE 256 1456 256 1744
            WIRE 256 1744 256 1920
            WIRE 256 1744 528 1744
            WIRE 528 1744 1728 1744
            WIRE 1728 1744 2176 1744
            WIRE 2176 1744 2896 1744
            WIRE 528 1744 528 1952
            WIRE 528 1952 848 1952
            WIRE 256 1456 272 1456
            WIRE 1728 960 1728 1744
            WIRE 2176 560 2208 560
            WIRE 2176 560 2176 1744
            WIRE 2896 1008 2896 1744
        END BRANCH
        BEGIN BRANCH XLXN_86(31:0)
            WIRE 2640 432 2656 432
            WIRE 2656 432 2656 704
            WIRE 2656 704 2752 704
        END BRANCH
        BEGIN INSTANCE sub1 2752 592 R0
        END INSTANCE
        BEGIN BRANCH MUL1_RDY
            WIRE 720 1840 720 2032
            WIRE 720 2032 848 2032
            WIRE 720 1840 2112 1840
            WIRE 2096 784 2112 784
            WIRE 2112 784 2112 1840
        END BRANCH
        BEGIN BRANCH sub1_rdy
            WIRE 768 2272 848 2272
            WIRE 768 2272 768 2528
            WIRE 768 2528 3312 2528
            WIRE 3264 832 3312 832
            WIRE 3312 832 3312 2528
        END BRANCH
        BEGIN BRANCH sub_nd
            WIRE 1328 2272 1360 2272
            WIRE 1360 2272 2128 2272
            WIRE 2128 800 2752 800
            WIRE 2128 800 2128 2272
        END BRANCH
        IOMARKER 1472 2208 RDY R0 28
    END SHEET
END SCHEMATIC
