VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "virtex4"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL mult_a(31:0)
        SIGNAL mult_b(31:0)
        SIGNAL mult1_res(31:0)
        SIGNAL a11(31:0)
        SIGNAL a12(31:0)
        SIGNAL a21(31:0)
        SIGNAL a22(31:0)
        SIGNAL a31(31:0)
        SIGNAL a32(31:0)
        SIGNAL reset
        SIGNAL add_a_val(31:0)
        SIGNAL exp1m_reg(31:0)
        SIGNAL exp2m_reg(31:0)
        SIGNAL exp3m_reg(31:0)
        SIGNAL add1_res(31:0)
        SIGNAL dbg_mult_nd
        SIGNAL dbg_add_nd
        SIGNAL clk
        SIGNAL dbg_exp1m_load
        SIGNAL add1_rdy
        SIGNAL mult1_rdy
        SIGNAL add_b_val(31:0)
        SIGNAL XLXN_205(31:0)
        SIGNAL exp1(31:0)
        SIGNAL start
        SIGNAL exp3(31:0)
        SIGNAL exp2(31:0)
        SIGNAL rdy
        SIGNAL dbg_exp1_ld
        SIGNAL XLXN_251
        SIGNAL XLXN_252
        SIGNAL XLXN_276(3:0)
        SIGNAL XLXN_284
        SIGNAL XLXN_285
        SIGNAL XLXN_294(1:0)
        SIGNAL XLXN_295
        PORT Input a11(31:0)
        PORT Input a12(31:0)
        PORT Input a21(31:0)
        PORT Input a22(31:0)
        PORT Input a31(31:0)
        PORT Input a32(31:0)
        PORT Input reset
        PORT Input clk
        PORT Output exp1(31:0)
        PORT Input start
        PORT Output exp3(31:0)
        PORT Output exp2(31:0)
        PORT Output rdy
        BEGIN BLOCKDEF router_6_2
            TIMESTAMP 2007 6 27 20 6 8
            RECTANGLE N 64 -448 320 0 
            RECTANGLE N 0 -428 64 -404 
            LINE N 64 -416 0 -416 
            RECTANGLE N 0 -364 64 -340 
            LINE N 64 -352 0 -352 
            RECTANGLE N 0 -300 64 -276 
            LINE N 64 -288 0 -288 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 320 -428 384 -404 
            LINE N 320 -416 384 -416 
            RECTANGLE N 320 -44 384 -20 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF mult_fp
            TIMESTAMP 2007 6 29 1 14 46
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCKDEF reg32
            TIMESTAMP 2007 6 27 20 6 4
            RECTANGLE N 64 -256 368 0 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF mux32_2
            TIMESTAMP 2007 6 27 20 5 36
            RECTANGLE N 64 -192 368 0 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -172 432 -148 
            LINE N 368 -160 432 -160 
        END BLOCKDEF
        BEGIN BLOCKDEF signal_inversor_fp
            TIMESTAMP 2007 6 27 20 6 12
            RECTANGLE N 64 -64 400 0 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 400 -44 464 -20 
            LINE N 400 -32 464 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF mux32_3
            TIMESTAMP 2007 6 27 20 5 54
            RECTANGLE N 64 -256 368 0 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            RECTANGLE N 368 -236 432 -212 
            LINE N 368 -224 432 -224 
        END BLOCKDEF
        BEGIN BLOCKDEF EXPS_CALC_CONTROL
            TIMESTAMP 2007 6 29 1 26 54
            RECTANGLE N 64 -768 384 0 
            LINE N 64 -736 0 -736 
            LINE N 64 -560 0 -560 
            LINE N 64 -384 0 -384 
            LINE N 64 -208 0 -208 
            LINE N 64 -32 0 -32 
            LINE N 384 -736 448 -736 
            LINE N 384 -672 448 -672 
            LINE N 384 -608 448 -608 
            LINE N 384 -544 448 -544 
            LINE N 384 -480 448 -480 
            LINE N 384 -416 448 -416 
            LINE N 384 -352 448 -352 
            LINE N 384 -288 448 -288 
            LINE N 384 -224 448 -224 
            LINE N 384 -160 448 -160 
            RECTANGLE N 384 -108 448 -84 
            LINE N 384 -96 448 -96 
            RECTANGLE N 384 -44 448 -20 
            LINE N 384 -32 448 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF add_fp
            TIMESTAMP 2007 6 29 1 3 43
            RECTANGLE N 32 32 480 384 
            BEGIN LINE W 0 80 32 80 
            END LINE
            BEGIN LINE W 0 112 32 112 
            END LINE
            LINE N 0 208 32 208 
            LINE N 0 240 32 240 
            LINE N 0 304 32 304 
            LINE N 144 416 144 384 
            BEGIN LINE W 512 80 480 80 
            END LINE
            LINE N 512 240 480 240 
        END BLOCKDEF
        BEGIN BLOCK router router_6_2
            PIN a11(31:0) a11(31:0)
            PIN a12(31:0) a12(31:0)
            PIN a21(31:0) a21(31:0)
            PIN a22(31:0) a22(31:0)
            PIN a31(31:0) a31(31:0)
            PIN a32(31:0) a32(31:0)
            PIN selector(3:0) XLXN_276(3:0)
            PIN a(31:0) mult_a(31:0)
            PIN b(31:0) mult_b(31:0)
        END BLOCK
        BEGIN BLOCK mult_fp_1 mult_fp
            PIN a(31:0) mult_a(31:0)
            PIN b(31:0) mult_b(31:0)
            PIN operation_nd dbg_mult_nd
            PIN operation_rfd
            PIN sclr reset
            PIN clk clk
            PIN result(31:0) mult1_res(31:0)
            PIN rdy mult1_rdy
        END BLOCK
        BEGIN BLOCK add_b_mux mux32_2
            PIN SELECTOR XLXN_295
            PIN A(31:0) mult1_res(31:0)
            PIN B(31:0) add1_res(31:0)
            PIN OUTPUT(31:0) add_b_val(31:0)
        END BLOCK
        BEGIN BLOCK exp1_mult reg32
            PIN LOAD dbg_exp1m_load
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) mult1_res(31:0)
            PIN OUTPUT(31:0) exp1m_reg(31:0)
        END BLOCK
        BEGIN BLOCK exp2_mult reg32
            PIN LOAD XLXN_285
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) mult1_res(31:0)
            PIN OUTPUT(31:0) exp2m_reg(31:0)
        END BLOCK
        BEGIN BLOCK exp3_mult reg32
            PIN LOAD XLXN_284
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) mult1_res(31:0)
            PIN OUTPUT(31:0) exp3m_reg(31:0)
        END BLOCK
        BEGIN BLOCK add_a_mux mux32_3
            PIN a(31:0) exp1m_reg(31:0)
            PIN b(31:0) exp2m_reg(31:0)
            PIN c(31:0) exp3m_reg(31:0)
            PIN selector(1:0) XLXN_294(1:0)
            PIN selected(31:0) add_a_val(31:0)
        END BLOCK
        BEGIN BLOCK exp1_value reg32
            PIN LOAD dbg_exp1_ld
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) add1_res(31:0)
            PIN OUTPUT(31:0) exp1(31:0)
        END BLOCK
        BEGIN BLOCK CTRL EXPS_CALC_CONTROL
            PIN CLK clk
            PIN add1_rdy add1_rdy
            PIN mult1_rdy mult1_rdy
            PIN SCLR reset
            PIN START start
            PIN add1_nd dbg_add_nd
            PIN add_b_mux_sel XLXN_295
            PIN exp1_load dbg_exp1_ld
            PIN exp1m_reg_load dbg_exp1m_load
            PIN exp2_load XLXN_251
            PIN exp2m_reg_load XLXN_285
            PIN exp3_load XLXN_252
            PIN exp3m_reg_load XLXN_284
            PIN mult1_nd dbg_mult_nd
            PIN RDY rdy
            PIN add_a_mux_sel(1:0) XLXN_294(1:0)
            PIN router_sel(3:0) XLXN_276(3:0)
        END BLOCK
        BEGIN BLOCK exp3_value reg32
            PIN LOAD XLXN_252
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) XLXN_205(31:0)
            PIN OUTPUT(31:0) exp3(31:0)
        END BLOCK
        BEGIN BLOCK exp2_value reg32
            PIN LOAD XLXN_251
            PIN RESET reset
            PIN CLK clk
            PIN INPUT(31:0) add1_res(31:0)
            PIN OUTPUT(31:0) exp2(31:0)
        END BLOCK
        BEGIN BLOCK sign_inv_fp signal_inversor_fp
            PIN input_val(31:0) add1_res(31:0)
            PIN output_val(31:0) XLXN_205(31:0)
        END BLOCK
        BEGIN BLOCK XLXI_1 add_fp
            PIN a(31:0) add_a_val(31:0)
            PIN b(31:0) add_b_val(31:0)
            PIN operation_nd dbg_add_nd
            PIN operation_rfd
            PIN sclr reset
            PIN clk clk
            PIN result(31:0) add1_res(31:0)
            PIN rdy add1_rdy
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN INSTANCE router 384 736 R0
        END INSTANCE
        BEGIN INSTANCE mult_fp_1 1072 304 R0
        END INSTANCE
        BEGIN BRANCH a11(31:0)
            WIRE 240 320 384 320
        END BRANCH
        BEGIN BRANCH a12(31:0)
            WIRE 240 384 384 384
        END BRANCH
        BEGIN BRANCH a21(31:0)
            WIRE 240 448 384 448
        END BRANCH
        BEGIN BRANCH a22(31:0)
            WIRE 240 512 384 512
        END BRANCH
        BEGIN BRANCH a31(31:0)
            WIRE 240 576 384 576
        END BRANCH
        BEGIN BRANCH a32(31:0)
            WIRE 240 640 384 640
        END BRANCH
        IOMARKER 240 320 a11(31:0) R180 28
        IOMARKER 240 384 a12(31:0) R180 28
        IOMARKER 240 448 a21(31:0) R180 28
        IOMARKER 240 512 a22(31:0) R180 28
        IOMARKER 240 576 a31(31:0) R180 28
        IOMARKER 240 640 a32(31:0) R180 28
        BEGIN BRANCH XLXN_205(31:0)
            WIRE 2896 2560 2912 2560
            WIRE 2912 2448 2928 2448
            WIRE 2912 2448 2912 2560
        END BRANCH
        IOMARKER 3360 1440 exp1(31:0) R0 28
        BEGIN BRANCH exp1(31:0)
            WIRE 3328 1456 3360 1456
            WIRE 3360 1440 3360 1456
        END BRANCH
        BEGIN INSTANCE exp1_value 2896 1680 R0
        END INSTANCE
        BEGIN BRANCH start
            WIRE 1792 816 1984 816
        END BRANCH
        IOMARKER 1792 816 start R180 28
        BEGIN BRANCH exp3(31:0)
            WIRE 3360 2256 3376 2256
        END BRANCH
        BEGIN INSTANCE exp3_value 2928 2480 R0
        END INSTANCE
        IOMARKER 3376 2256 exp3(31:0) R0 28
        IOMARKER 96 928 reset R180 28
        IOMARKER 64 960 clk R180 28
        BEGIN BRANCH exp2(31:0)
            WIRE 3328 1776 3360 1776
        END BRANCH
        BEGIN INSTANCE exp2_value 2896 2000 R0
        END INSTANCE
        IOMARKER 3360 1776 exp2(31:0) R0 28
        BEGIN BRANCH rdy
            WIRE 2432 688 3296 688
        END BRANCH
        IOMARKER 3296 688 rdy R0 28
        BEGIN BRANCH XLXN_251
            WIRE 2432 368 2880 368
            WIRE 2880 368 2880 1776
            WIRE 2880 1776 2896 1776
        END BRANCH
        BEGIN BRANCH XLXN_252
            WIRE 2432 496 2864 496
            WIRE 2864 496 2864 2256
            WIRE 2864 2256 2928 2256
        END BRANCH
        BEGIN BRANCH reset
            WIRE 96 928 128 928
            WIRE 128 928 1072 928
            WIRE 1072 928 1872 928
            WIRE 1872 928 2800 928
            WIRE 2800 928 2800 1520
            WIRE 2800 1520 2896 1520
            WIRE 2800 1520 2800 1840
            WIRE 2800 1840 2896 1840
            WIRE 2800 1840 2800 2320
            WIRE 2800 2320 2928 2320
            WIRE 128 928 128 1136
            WIRE 128 1136 128 1568
            WIRE 128 1568 128 2000
            WIRE 128 2000 128 2656
            WIRE 128 2656 1680 2656
            WIRE 128 2000 496 2000
            WIRE 128 1568 496 1568
            WIRE 128 1136 496 1136
            WIRE 1072 608 1072 928
            WIRE 1680 1712 1712 1712
            WIRE 1680 1712 1680 2656
            WIRE 1872 640 1872 928
            WIRE 1872 640 1984 640
        END BRANCH
        BEGIN BRANCH clk
            WIRE 64 960 96 960
            WIRE 96 960 1216 960
            WIRE 1216 960 1840 960
            WIRE 1840 960 2784 960
            WIRE 2784 960 2784 1584
            WIRE 2784 1584 2896 1584
            WIRE 2784 1584 2784 1904
            WIRE 2784 1904 2896 1904
            WIRE 2784 1904 2784 2384
            WIRE 2784 2384 2928 2384
            WIRE 96 960 96 1200
            WIRE 96 1200 96 1632
            WIRE 96 1632 96 2064
            WIRE 96 2064 96 2688
            WIRE 96 2688 1856 2688
            WIRE 96 2064 496 2064
            WIRE 96 1632 496 1632
            WIRE 96 1200 496 1200
            WIRE 1216 720 1216 960
            WIRE 1840 112 1840 960
            WIRE 1840 112 1984 112
            WIRE 1856 1824 1856 2688
        END BRANCH
        BEGIN INSTANCE CTRL 1984 848 R0
        END INSTANCE
        BEGIN INSTANCE exp3_mult 496 2160 R0
        END INSTANCE
        BEGIN INSTANCE exp2_mult 496 1728 R0
        END INSTANCE
        BEGIN INSTANCE exp1_mult 496 1296 R0
        END INSTANCE
        BEGIN INSTANCE sign_inv_fp 2432 2592 R0
        END INSTANCE
        BEGIN INSTANCE add_a_mux 1280 1296 R0
        END INSTANCE
        BEGIN BRANCH XLXN_276(3:0)
            WIRE 304 704 304 896
            WIRE 304 896 2480 896
            WIRE 304 704 384 704
            WIRE 2432 816 2480 816
            WIRE 2480 816 2480 896
        END BRANCH
        BEGIN BRANCH XLXN_284
            WIRE 272 1936 272 2224
            WIRE 272 2224 2704 2224
            WIRE 272 1936 496 1936
            WIRE 2432 560 2704 560
            WIRE 2704 560 2704 2224
        END BRANCH
        BEGIN BRANCH XLXN_294(1:0)
            WIRE 1200 1264 1200 1328
            WIRE 1200 1328 2512 1328
            WIRE 1200 1264 1280 1264
            WIRE 2432 752 2512 752
            WIRE 2512 752 2512 1328
        END BRANCH
        BEGIN BRANCH XLXN_285
            WIRE 256 1504 256 2240
            WIRE 256 2240 2720 2240
            WIRE 256 1504 496 1504
            WIRE 2432 432 2720 432
            WIRE 2720 432 2720 2240
        END BRANCH
        BEGIN INSTANCE add_b_mux 816 2528 R0
        END INSTANCE
        BEGIN BRANCH XLXN_295
            WIRE 736 2320 736 2368
            WIRE 736 2368 816 2368
            WIRE 736 2320 2448 2320
            WIRE 2432 176 2448 176
            WIRE 2448 176 2448 2320
        END BRANCH
        BEGIN INSTANCE XLXI_1 1712 1408 R0
        END INSTANCE
        BEGIN BRANCH mult_a(31:0)
            WIRE 768 320 784 320
            WIRE 784 320 784 384
            WIRE 784 384 1072 384
        END BRANCH
        BEGIN BRANCH mult_b(31:0)
            WIRE 768 704 784 704
            WIRE 784 416 784 704
            WIRE 784 416 1072 416
        END BRANCH
        BEGIN BRANCH mult1_rdy
            WIRE 1584 544 1776 544
            WIRE 1776 464 1984 464
            WIRE 1776 464 1776 544
        END BRANCH
        BEGIN BRANCH mult1_res(31:0)
            WIRE 192 784 192 1264
            WIRE 192 1264 192 1696
            WIRE 192 1696 192 2128
            WIRE 192 2128 496 2128
            WIRE 192 2128 192 2432
            WIRE 192 2432 816 2432
            WIRE 192 1696 496 1696
            WIRE 192 1264 496 1264
            WIRE 192 784 1648 784
            WIRE 1584 384 1648 384
            WIRE 1648 384 1648 784
        END BRANCH
        BEGIN BRANCH dbg_mult_nd
            WIRE 1008 48 1008 512
            WIRE 1008 512 1072 512
            WIRE 1008 48 2656 48
            WIRE 2656 48 2656 624
            WIRE 2432 624 2656 624
        END BRANCH
        BEGIN BRANCH dbg_exp1m_load
            WIRE 240 1072 496 1072
            WIRE 240 1072 240 2256
            WIRE 240 2256 2736 2256
            WIRE 2432 304 2736 304
            WIRE 2736 304 2736 2256
        END BRANCH
        BEGIN BRANCH dbg_exp1_ld
            WIRE 2432 240 2896 240
            WIRE 2896 240 2896 1456
        END BRANCH
        BEGIN BRANCH dbg_add_nd
            WIRE 1472 1392 1472 1616
            WIRE 1472 1616 1712 1616
            WIRE 1472 1392 2576 1392
            WIRE 2432 112 2576 112
            WIRE 2576 112 2576 1392
        END BRANCH
        BEGIN BRANCH add1_res(31:0)
            WIRE 736 2496 816 2496
            WIRE 736 2496 736 2560
            WIRE 736 2560 2400 2560
            WIRE 2400 2560 2432 2560
            WIRE 2224 1488 2400 1488
            WIRE 2400 1488 2400 1648
            WIRE 2400 1648 2896 1648
            WIRE 2400 1648 2400 1968
            WIRE 2400 1968 2896 1968
            WIRE 2400 1968 2400 2560
        END BRANCH
        BEGIN BRANCH add1_rdy
            WIRE 1904 288 1984 288
            WIRE 1904 288 1904 1040
            WIRE 1904 1040 2288 1040
            WIRE 2288 1040 2288 1648
            WIRE 2224 1648 2288 1648
        END BRANCH
        BEGIN BRANCH exp3m_reg(31:0)
            WIRE 928 1936 1088 1936
            WIRE 1088 1200 1280 1200
            WIRE 1088 1200 1088 1936
        END BRANCH
        BEGIN BRANCH exp2m_reg(31:0)
            WIRE 928 1504 1040 1504
            WIRE 1040 1136 1280 1136
            WIRE 1040 1136 1040 1504
        END BRANCH
        BEGIN BRANCH add_a_val(31:0)
            WIRE 1552 1408 1872 1408
            WIRE 1552 1408 1552 1488
            WIRE 1552 1488 1712 1488
            WIRE 1712 1072 1872 1072
            WIRE 1872 1072 1872 1408
        END BRANCH
        BEGIN BRANCH add_b_val(31:0)
            WIRE 1248 2368 1552 2368
            WIRE 1552 1520 1552 2368
            WIRE 1552 1520 1712 1520
        END BRANCH
        BEGIN BRANCH exp1m_reg(31:0)
            WIRE 928 1072 976 1072
            WIRE 976 1072 1280 1072
        END BRANCH
    END SHEET
END SCHEMATIC
