----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:02:36 06/04/2007 
-- Design Name: 
-- Module Name:    reg32 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity reg32 is
    Port ( INPUT : in  STD_LOGIC_VECTOR (31 downto 0);
			  LOAD  : in  STD_LOGIC;
           RESET : in  STD_LOGIC;
			  CLK   : in  STD_LOGIC;
           OUTPUT : out  STD_LOGIC_VECTOR (31 downto 0)
           );
end reg32;

architecture Behavioral of reg32 is
begin
	process (CLK)
	begin
		if CLK'event and CLK='1' then  
			if RESET='1' then
				OUTPUT <= "00000000000000000000000000000000";
			elsif LOAD='1' then
				OUTPUT <= INPUT;
			end if;			
		end if;
	end process;

end Behavioral;

