----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:41:38 06/20/2007 
-- Design Name: 
-- Module Name:    mux32_9 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux32_9 is
    Port ( in0 : in  STD_LOGIC_VECTOR (31 downto 0);
           in1 : in  STD_LOGIC_VECTOR (31 downto 0);
           in2 : in  STD_LOGIC_VECTOR (31 downto 0);
           in3 : in  STD_LOGIC_VECTOR (31 downto 0);
           in4 : in  STD_LOGIC_VECTOR (31 downto 0);
           in5 : in  STD_LOGIC_VECTOR (31 downto 0);
           in6 : in  STD_LOGIC_VECTOR (31 downto 0);
           in7 : in  STD_LOGIC_VECTOR (31 downto 0);
           in8 : in  STD_LOGIC_VECTOR (31 downto 0);
           selector : in  STD_LOGIC_VECTOR (3 downto 0);
           selected : out  STD_LOGIC_VECTOR (31 downto 0));
end mux32_9;

architecture Behavioral of mux32_9 is

begin

	process (selector, in0, in1, in2, in3, in4, in5, in6, in7, in8)
	begin
		case selector is
			when "0000" => selected <= in0;
			when "0001" => selected <= in1;
			when "0010" => selected <= in2;
			when "0011" => selected <= in3;
			when "0100" => selected <= in4;
			when "0101" => selected <= in5;
			when "0110" => selected <= in6;
			when "0111" => selected <= in7; 
			when "1000" => selected <= in8; 		
			when others => selected <= "11111111111111111111111111111111";
		end case;
	end process;

end Behavioral;

